import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
public class Square extends Actor
{
    GreenfootImage sand = new GreenfootImage("sand.jpg");
    GreenfootImage flagged = new GreenfootImage("flagged.png");
    boolean isFlagged = false;
    MouseInfo mouse = Greenfoot.getMouseInfo();
    public void act() 
    {
        Game game = (Game)getWorld();
        FlagCounter flagger = game.getFlagger();
        MouseInfo mouse = Greenfoot.getMouseInfo();
        if (mouse != null) {
            if (Greenfoot.mouseClicked(this)) {
                int button = mouse.getButton();
                if (button == 3 && !isFlagged) {
                    isFlagged = true;
                    setImage(flagged);
                    flagger.flag();
                } else if (button == 3 && isFlagged) {
                    isFlagged = false;
                    setImage(sand);
                    flagger.unflag();
                }else if (button == 1 && !isFlagged) {
                    revealTiles();
                }
            }
        }
    }
    public void revealTiles() {
        if (getOneIntersectingObject(Numbers.class) == null) {
            List<Square> nearbySquares = new ArrayList<>();
            int x = getX();
            int y = getY();
            if (getOneObjectAtOffset(1,0,Square.class) != null) {
                nearbySquares.add((Square)getWorld().getObjectsAt(x+1,y,Square.class).get(0));
            }
            if (getOneObjectAtOffset(-1,0,Square.class) != null) {
                nearbySquares.add((Square)getWorld().getObjectsAt(x-1,y,Square.class).get(0));
            }
            if (getOneObjectAtOffset(0,1,Square.class) != null) {
                nearbySquares.add((Square)getWorld().getObjectsAt(x,y+1,Square.class).get(0));
            }
            if (getOneObjectAtOffset(0,-1,Square.class) != null) {
                nearbySquares.add((Square)getWorld().getObjectsAt(x,y-1,Square.class).get(0));
            }
            getWorld().removeObject(this);
            for (Square nearbySquare : nearbySquares) {
                if (nearbySquare.getWorld() != null)  nearbySquare.revealTiles();
            }
            nearbySquares.clear();
        } else {
            getWorld().removeObject(this);
        }
    }
    /*public void revealTiles() {
        int number = ((Numbers)getOneIntersectingObject(Numbers.class)).numberOfBombs();
        if (number == 0) {
            List<Square> nearbySquares = new ArrayList<>();
            if (getOneObjectAtOffset(1,0,Square.class) != null) {
                nearbySquares.add((Square)getOneObjectAtOffset(1,0,Square.class));
            }
            if (getOneObjectAtOffset(-1,0,Square.class) != null) {
                nearbySquares.add((Square)getOneObjectAtOffset(-1,0,Square.class));
            }
            if (getOneObjectAtOffset(0,1,Square.class) != null) {
                nearbySquares.add((Square)getOneObjectAtOffset(0,1,Square.class));
            }
            if (getOneObjectAtOffset(0,-1,Square.class) != null) {
                nearbySquares.add((Square)getOneObjectAtOffset(0,-1,Square.class));
            }
            getWorld().removeObject(this);
            for (Square nearbySquare : nearbySquares) {
                nearbySquare.revealTiles();
            }
            nearbySquares.clear();
        } else if (number > 0) {
            getWorld().removeObject(this);
        }
    }*/
    /*public void revealTiles() {
        int num = ((Numbers)getOneObjectAtOffset(0, 0, Numbers.class)).numberOfBombs();
        java.util.List<Square> nearby = (java.util.List<Square>)getNeighbours(1, false, Square.class);
        java.util.List<Square> valid = new java.util.ArrayList<Square>();
        for (Square square : nearby)
        {
            if (num == ((Numbers)getWorld().getObjectsAt(square.getX(), square.getY(), Numbers.class).get(0)).numberOfBombs())
            {
                valid.add(square);
            }
        }
        getWorld().removeObject(this);
        for (Square square : valid) square.revealTiles();
    }*/
}